/** \addtogroup tuePrvTrackMerge
 * @{
 * \file        tue_prv_trackMerge_int.h
 * \brief       internal header for track merge
 *
 * 
 *
 *
 *          (C) Copyright Tuerme Inc. All rights reserved.
 *
 */

#ifndef TUE_PRV_TRACKMERGE_INT_H
#define TUE_PRV_TRACKMERGE_INT_H

#ifdef __cplusplus
extern "C" {
#endif

/*==================[inclusions]============================================*/
#include "tue_prv_common_types.h" /*uint16, float32*/
#include "TueObjFusn_DistMatrix.h"
#include "TueObjFusn_EgoMotionType.h"
/*==================[macros]================================================*/

/*==================[type definitions]======================================*/
#define TUE_PRV_TRACKMERGE_FACTOR_GATE (1.2f)

/*==================[forward declarations]==================================*/
/*==================[symbolic constants]====================================*/
/*==================[return codes]==========================================*/
/*==================[functions]=============================================*/

#define ObjFusn_START_SEC_CODE

LOCAL uint32 trackMerge_mergeTrkble(CONSTP2VAR(TueObjFusn_TrackableType, AUTOMATIC, ObjFusn_VAR_NOINIT) pTrackA,
                                    CONSTP2VAR(TueObjFusn_TrackableType, AUTOMATIC, ObjFusn_VAR_NOINIT) pTrackB,
                                    CONSTP2CONST(TueObjFusn_EgoMotionType, AUTOMATIC, ObjFusn_VAR_NOINIT) pEgoMotion);
#define ObjFusn_STOP_SEC_CODE


#define ObjFusn_START_SEC_CODE

LOCAL uint32 trackMerge_distanceCam2Radar(CONSTP2CONST(TueObjFusn_TrackableListType, AUTOMATIC, ObjFusn_VAR_NOINIT) pTrackList,
                                          const float32 f32MatchGate,
                                          CONSTP2VAR(stDistMatrix_t, AUTOMATIC, ObjFusn_VAR_NOINIT) pDist_mat,
                                          const uint16 au16IdxRadarOnlyTracks[], const uint16 u16NumRadarOnlyTracks,
                                          const uint16 au16IdxVisionOnlyTracks[], const uint16 u16NumVisionOnlyTracks,
                                          CONSTP2CONST(TueObjFusn_EgoMotionType, AUTOMATIC, ObjFusn_VAR_NOINIT) pEgoMotion);
#define ObjFusn_STOP_SEC_CODE


#define ObjFusn_START_SEC_CODE

LOCAL uint32  trackMerge_findNonFusedTracks(CONSTP2CONST(TueObjFusn_TrackableListType, AUTOMATIC, ObjFusn_VAR_NOINIT) pTrackList,
                                                                 uint16 au16IdxRadarOnlyTracks[], const uint16 u16nElementsRadarToDistMatrix,
                                                                 CONSTP2VAR(uint16, AUTOMATIC, ObjFusn_VAR_NOINIT) pu16NumRadarOnlyTracks, 
                                                                 uint16 au16IdxVisionOnlyTracks[], const uint16 u16nElementsVisionToDistMatrix,
                                                                 CONSTP2VAR(uint16, AUTOMATIC, ObjFusn_VAR_NOINIT) pu16NumVisionOnlyTracks);
#define ObjFusn_STOP_SEC_CODE

/*==================[external function declarations]========================*/
/*==================[external constants]====================================*/
/*==================[external data]=========================================*/

#ifdef __cplusplus
}
#endif

#endif /* TUE_PRV_TRACKMERGE_INT_H */
/**
 * @}
 */
/*==================[end of file]===========================================*/
